// Show Sled
// Just show an interface that lets you play the sled going
// at constant motion 

var clearHandler =
{
	actionPerformed: function(evt)
	{
		objectView.repaint();
	}
};
var clearListener = new ActionListener(clearHandler);

var startHandler =
{
	actionPerformed: function(evt)
	{
		if (world.isRunning())
		{
			objectView.stop()
			setupPlayButton("play")
			objectView.repaint()
		}
		else
		{
			objectView.start();
			setupPlayButton("pause")
			objectView.repaint();
		}
	}
};
var startListener = new ActionListener(startHandler);

var resetHandler =
{
	actionPerformed: function(evt)
	{
		setupPlayButton("play")
		world.getAtoms().elementAt(0).clearForces()
		objectView.reset()
		//warnBox.setText(blank);
		//warningTextShowed = false;
		startButton.setEnabled(true)
		objectView.repaint()
	}
};
var resetListener = new ActionListener(resetHandler);

function setupPlayButton(strL)
{
	if (strL.equals("play"))
	{
		startButton.setText("Play");
		startButton.setToolTipText("Click here to start the model.");
	}
	else if (strL.equals("pause"))
	{
		startButton.setText("Pause");
		startButton.setToolTipText("Click here to pause the model.");
	}
}

function enter()
{
    // remove all forces code -- we're not applying forces

	world = objectView.getWorldModel();
 	//world.addStepListener(stepsListener,50);

	setupView();

 	sledAtom = JAtom.createAtom(140,180,10,5,0);
	sledAtom.setIconFromURL(currentNode.getResource("Resources/snowmobile.gif"));
	objectView.addElement(sledAtom);
	sledAtom.setProperty("showvel",true);

	sledAtom.setProperty("showvelnumber",true);
	sledAtom.setProperty("dotrace",true);
	sledAtom.setTraceProperties(0,1,0.2*objectView.getWorldModel().getPxFromCm(1));
	objectView.setShowUnitLabels(true);
	startButton.addActionListener(startListener);
	resetButton.addActionListener(resetListener);

    // set this page's instructions
    instructionsView.setText(instructionsShowSledText);
}

function setupView()
{
	JPartWorld.setNeedScreenResolution(20)
	objectView.clearAll()
	objectView.clearBackgroundIcon()
	objectView.setBackground(Color.white);
	objectView.setBackgroundIcon(currentNode.getResource("Resources/snowBackground.gif"));
	objectView.setGrid()
	world = objectView.getWorldModel();
	objectView.setSnapToGrid(true, true)
	objectView.getGrid().setIntervalMajor(5,5)
	world.setDoAACollisions(true)
	objectView.setAtomsDragMode(GUIPanel.DRAG_MODE_NONE);
}

function exit() 
{
	startButton.removeActionListener(startListener);
	resetButton.removeActionListener(resetListener);
	objectView.removeElement(sledAtom);
}