// Load Sled
var motorForce;
var forceDown = false;
var forceUp = false;
var forceUp2 = false;
var forceNum;
var forceResist;
var appliedForces;
var triedNum = 0;

var clearHandler =
{
	actionPerformed: function(evt)
	{
	 	sledForces.clearForces();
		forceDown=false;
		forceUp=false;
		forceUp2=false;
		objectView.repaint();
	}
};
var clearListener = new ActionListener(clearHandler);

var startHandler =
{
        actionPerformed: function(evt)
        {
                if (world.isRunning())
                {
                        objectView.stop()
                        setupPlayButton("play")
                        objectView.repaint()
                }
                else
                {
                        forceNum=sledForces.getNumbAppliedForces();
                        var studentForce = forceNum;
                        //login.logAction(3,"Student added "+studentForce+" forces on the boat.");
                        appliedForces=new Array(forceNum);
                        triedNum+=1;
                        for(var i=0;i<forceNum;i++)
                        {

                                appliedForces[i]=sledForces.getNthForce(i);
                                var f_x=appliedForces[i].getProjectionX(null);
                                var f_y=appliedForces[i].getProjectionY(null);
                                if(f_y>=-0.01&&f_y<=0.01&&f_x<=-2.99 &&f_x>=-3.01)
                                        forceResist=true;
                                //login.logAction(5,"Force"+i+"     =( "+f_x+","+ f_y+")");
                        }
                        if(forceNum<1)
                        {       
                                sledForces.setCollisionSensitive(false);
                                //if (warnBox.getText()!=noForceOnBoat2)
                                //      warnBox.setText(noForceOnBoat2);
                        }
                        else 
                        {
                                sledForces.setCollisionSensitive(true);
                        }
                        objectView.start();
            sledForces.setVisible(false);
                        setupPlayButton("pause")
                        objectView.repaint();
                }
        }
};
var startListener = new ActionListener(startHandler);

var resetHandler =
{
        actionPerformed: function(evt)
        {
                setupPlayButton("play")

                // clear all forces and put motor force back
                sledAtom.clearForces();
                sledAtom.applyForce(motorForce);
                sledForces.clearForces();
                sledForces.setVisible(true);
                objectView.reset()
                //warnBox.setText(blank);
                //warningTextShowed = false;
                startButton.setEnabled(true)
                forceDown=false;
                forceUp=false; 
                forceUp2=false;
                objectView.repaint()
        }
};
var resetListener = new ActionListener(resetHandler);

function setupPlayButton(strL)
{
        if (strL.equals("play"))
        {
                startButton.setText("Play");
                startButton.setToolTipText("Click here to start the model.");
        }
        else if (strL.equals("pause"))
        {
                startButton.setText("Pause");
                startButton.setToolTipText("Click here to pause the model.");
        }
}

function enter()
{
        // allow user to draw force arrows
        sledForces = JImpulseDaemon.createMultiConstantForceDaemon(140,180,10,10,0,0)
        sledForces.setForceDrawMode(CCConstantForce.DRAW_MODE_ARROW);
        sledForces.clearForces();
        sledForces.setDragMode(GUIPanel.DRAG_MODE_FORCE);

        world = objectView.getWorldModel();
        //world.addStepListener(stepsListener,50);

        objectView.setDaemonsDragMode(GUIPanel.DRAG_MODE_DAEMON);

        setupView();

        // create a constant force
        motorForce = new CCConstantForce(3.0, 0);
        motorForce.setDrawMode(CCConstantForce.DRAW_MODE_ARROW);

        sledAtom = JAtom.createAtom(140,180,10,5,0);
        sledAtom.setIconFromURL(currentNode.getResource("Resources/snowmobile.gif"));
        sledAtom.applyForce(motorForce);
        objectView.setDrawAtomsThenDaemons(true);
        objectView.addElement(sledAtom);
        sledAtom.setProperty("showvel",true);
        objectView.addElement(sledForces);

        sledAtom.setProperty("showvelnumber",true);
        sledAtom.setProperty("dotrace",true);
        sledAtom.setTraceProperties(0,1,0.2*objectView.getWorldModel().getPxFromCm(1));
        objectView.setShowUnitLabels(true);
        objectView.setShowForceNumber(true);
        startButton.addActionListener(startListener);
        resetButton.addActionListener(resetListener);

    // set this page's instructions
    instructionsView.setText(instructionsLoadSledText);
 
    // set prompt
    promptForNewtons.setText(promptNewtonsText);
}

function setupView()
{
	JPartWorld.setNeedScreenResolution(20)
	objectView.clearAll()
	objectView.clearBackgroundIcon()
	objectView.setBackground(Color.white);
	objectView.setBackgroundIcon(currentNode.getResource("Resources/snowBackground.gif"));
	objectView.setGrid()
	world = objectView.getWorldModel();
	objectView.setSnapToGrid(true, true)
	objectView.getGrid().setIntervalMajor(5,5)
	world.setDoAACollisions(true)
	objectView.setAtomsDragMode(GUIPanel.DRAG_MODE_NONE);
}

function exit() 
{
	startButton.removeActionListener(startListener);
	resetButton.removeActionListener(resetListener);
	objectView.removeElement(sledAtom);
}